@echo off

cd /d "%~dp0"

REM Passen Sie folgende Variablen ggf. an:(Ohne \ am Ende)======================

REM Installationsverzeichnis von 7z (http://www.7-zip.de/):
set zipdir=C:\Program Files\7-Zip
REM Installationsverzeichnis des DSS-Servers:
set quelle=C:\ASV\Server
REM  Zielverzeichnis der Sicherungsdatei:
set ziel=D:\asv-backup

REM Ende der Anpassungen====================================================


Echo ====================================================
Echo Erstellen eines Backups der ASV-Datenbank ASV-School
Echo ====================================================
Echo .
Echo Um eine Sicherung laufendem DSS-Server zu ermglichen wird
Echo eine Volumenschattenkopie mit Hilfe des Opensource-Tools hobocopy erstellt.
Echo ====================================================
Echo Zur Reduzierung des Speicherbedarfs wird die Datenbank mit 7-Zip komprimiert.

REM Generiere Ordnernamen
set ARCHIVNAME=SicherungASV-%DATE:~6,4%.%DATE:~3,2%.%DATE:~0,2%-%TIME:~0,2%.%TIME:~3,2%.%TIME:~6,2%

IF Exist %ziel%/nul (
    GOTO speichern
) ELSE (
    Echo Das Zielverzeichnis '%ziel%' existiert nicht.
    Echo Es wurde NICHTS gespeichert.
    Echo.
    GOTO Ende
)

:speichern

REM Kopiere
hobocopy /full /skipdenied /y /r "%quelle%\database" "%ziel%\%ARCHIVNAME%"

IF  Exist "%zipdir%\7z.exe" (
    GOTO verpacken
) ELSE (
    Echo =========================================
    Echo Kann das Programm 7-Zip nicht finden! 
    Echo Bitte installieren Sie das Programm und  
    Echo passen Sie ggf. den Installationspfad an!
    Echo =========================================
    Echo Belasse die 1:1 Kopie im Odner "%ziel%\%ARCHIVNAME%"
    
    GOTO Ende
)

:verpacken

REM Komprimiere und berprfe
"%zipdir%\7z.exe" a "%ziel%\%ARCHIVNAME%.7z" -ssw "%ziel%\%ARCHIVNAME%"
"%zipdir%\7z.exe" t "%ziel%\%ARCHIVNAME%.7z"
rd "%ziel%\%ARCHIVNAME%" /s /q

Echo.
Echo Backup-Vorgang abgeschlossen.
Echo.
Echo Eine Sicherung des Datenbankordners wurde in der
Echo Datei "%ziel%\%ARCHIVNAME%.7z" erstellt.
Echo.

:Ende
PAUSE